(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-webstorage-service'), require('@videogular/ngx-videogular/core'), require('@videogular/ngx-videogular/controls'), require('@videogular/ngx-videogular/overlay-play'), require('@videogular/ngx-videogular/buffering'), require('rxjs'), require('shepherd.js'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('@sourceloop/user-onboarding-client', ['exports', '@angular/core', 'ngx-webstorage-service', '@videogular/ngx-videogular/core', '@videogular/ngx-videogular/controls', '@videogular/ngx-videogular/overlay-play', '@videogular/ngx-videogular/buffering', 'rxjs', 'shepherd.js', '@angular/router'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.sourceloop = global.sourceloop || {}, global.sourceloop['user-onboarding-client'] = {}), global.ng.core, global.i1, global.core, global.controls, global.overlayPlay, global.buffering, global.rxjs, global.Shepherd, global.ng.router));
}(this, (function (exports, i0, i1, core, controls, overlayPlay, buffering, rxjs, Shepherd, i2) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var Shepherd__default = /*#__PURE__*/_interopDefaultLegacy(Shepherd);

    var UserOnboardingLibModule = /** @class */ (function () {
        function UserOnboardingLibModule() {
        }
        return UserOnboardingLibModule;
    }());
    UserOnboardingLibModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [],
                    imports: [
                        i1.StorageServiceModule,
                        core.VgCoreModule,
                        controls.VgControlsModule,
                        overlayPlay.VgOverlayPlayModule,
                        buffering.VgBufferingModule
                    ],
                    exports: []
                },] }
    ];

    var SaveSCommand = /** @class */ (function () {
        function SaveSCommand(storage) {
            this.storage = storage;
        }
        SaveSCommand.prototype.execute = function () {
            var newTourState = this.parameters.state;
            this.storage.set(newTourState.sessionId, newTourState);
            return rxjs.of(newTourState);
        };
        return SaveSCommand;
    }());
    var LoadSCommand = /** @class */ (function () {
        function LoadSCommand(storage) {
            this.storage = storage;
        }
        LoadSCommand.prototype.execute = function () {
            var currentState = this.storage.get(this.parameters.sessionId);
            return rxjs.of(currentState);
        };
        return LoadSCommand;
    }());

    var SaveTCommand = /** @class */ (function () {
        function SaveTCommand(storage) {
            this.storage = storage;
        }
        SaveTCommand.prototype.execute = function () {
            var newTour = {
                tourId: this.parameters.tourId,
                tourSteps: this.parameters.tourSteps,
                styleSheet: this.parameters.styleSheet,
            };
            this.storage.set(this.parameters.tourId, newTour);
            return rxjs.of(newTour);
        };
        return SaveTCommand;
    }());
    var LoadTCommand = /** @class */ (function () {
        function LoadTCommand(storage) {
            this.storage = storage;
        }
        LoadTCommand.prototype.execute = function () {
            var existingTour = this.storage.get(this.parameters.tourId);
            return rxjs.of(existingTour);
        };
        return LoadTCommand;
    }());

    var TourStoreServiceService = /** @class */ (function () {
        function TourStoreServiceService(storage) {
            this.storage = storage;
            this.commandMap = new Map();
            this.functionMap = new Map();
            this.defaultSSCommand = new SaveSCommand(this.storage);
            this.defaultSTCommand = new SaveTCommand(this.storage);
            this.defaultLSCommand = new LoadSCommand(this.storage);
            this.defaultLTCommand = new LoadTCommand(this.storage);
            this.commandMap.set('SaveTourCommand', this.defaultSTCommand);
            this.commandMap.set('LoadTourCommand', this.defaultLTCommand);
            this.commandMap.set('SaveStateCommand', this.defaultSSCommand);
            this.commandMap.set('LoadStateCommand', this.defaultLSCommand);
        }
        TourStoreServiceService.prototype.registerSaveTourCommand = function (cmd) {
            this.commandMap.set('SaveTourCommand', cmd);
        };
        TourStoreServiceService.prototype.registerLoadTourCommand = function (cmd) {
            this.commandMap.set('LoadTourCommand', cmd);
        };
        TourStoreServiceService.prototype.registerSaveStateCommand = function (cmd) {
            this.commandMap.set('SaveStateCommand', cmd);
        };
        TourStoreServiceService.prototype.registerLoadStateCommand = function (cmd) {
            this.commandMap.set('LoadStateCommand', cmd);
        };
        TourStoreServiceService.prototype.saveTour = function (parameters) {
            var command = this.commandMap.get('SaveTourCommand');
            command.parameters = parameters;
            return command.execute();
        };
        TourStoreServiceService.prototype.loadTour = function (parameters) {
            var command = this.commandMap.get('LoadTourCommand');
            command.parameters = parameters;
            return command.execute();
        };
        TourStoreServiceService.prototype.saveState = function (parameters) {
            var command = this.commandMap.get('SaveStateCommand');
            command.parameters = parameters;
            return command.execute();
        };
        TourStoreServiceService.prototype.loadState = function (parameters) {
            var command = this.commandMap.get('LoadStateCommand');
            command.parameters = parameters;
            return command.execute();
        };
        TourStoreServiceService.prototype.registerFnRef = function (key, fn) {
            this.functionMap.set(key, fn);
        };
        TourStoreServiceService.prototype.getFnByKey = function (key) {
            return this.functionMap.get(key);
        };
        TourStoreServiceService.prototype.createUUID = function () {
            var dt = new Date().getTime();
            var num1 = 16;
            var num2 = 0x3;
            var num3 = 0x8;
            var crypto = window.crypto || window.Crypto.prototype;
            var array = new Uint32Array(1);
            crypto.getRandomValues(array); // Compliant for security-sensitive use cases
            var FileId = array[0];
            return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (x) {
                var r = (dt + FileId * num1) % num1 || 0;
                dt = Math.floor(dt / num1);
                return (x === 'x' ? r : (r && num2) || num3).toString(num1);
            });
        };
        TourStoreServiceService.prototype.generateSessionId = function () {
            this.sessionId = this.createUUID();
            this.storage.set('TOUR_SESSION_ID', this.sessionId);
        };
        TourStoreServiceService.prototype.getSessionId = function () {
            return this.storage.get('TOUR_SESSION_ID');
        };
        return TourStoreServiceService;
    }());
    TourStoreServiceService.ɵprov = i0.ɵɵdefineInjectable({ factory: function TourStoreServiceService_Factory() { return new TourStoreServiceService(i0.ɵɵinject(i1.LOCAL_STORAGE)); }, token: TourStoreServiceService, providedIn: "root" });
    TourStoreServiceService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    TourStoreServiceService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [i1.LOCAL_STORAGE,] }] }
    ]; };

    var TourServiceService = /** @class */ (function () {
        function TourServiceService(tourStoreService, router) {
            this.tourStoreService = tourStoreService;
            this.router = router;
            this.interval = 100;
            this.tour = new Shepherd__default['default'].Tour({
                defaultStepOptions: {
                    cancelIcon: {
                        enabled: true,
                    },
                    classes: 'class-1 class-2',
                    scrollTo: { behavior: 'smooth', block: 'center' },
                },
            });
        }
        TourServiceService.prototype.addRemovedSteps = function (removedSteps) {
            var count = removedSteps.length;
            for (var i = 0; i < count; i++) {
                this.tour.steps.splice(0, 0, this.tour.steps.pop());
            }
        };
        TourServiceService.prototype.actionAssignment = function (e, b, wrapperNormalNext, wrapperNormalPrev, wrapperNext, wrapperPrev, func) {
            if (b.key === 'prevAction') {
                b.action =
                    e.prevRoute === e.currentRoute ? wrapperNormalPrev : wrapperPrev;
            }
            else if (b.key === 'nextAction') {
                b.action =
                    e.nextRoute === e.currentRoute ? wrapperNormalNext : wrapperNext;
            }
            else {
                b.action = func;
            }
        };
        TourServiceService.prototype.navigationCheckNext = function (event, e) {
            var _this = this;
            if (event instanceof i2.NavigationEnd && event.url === e.currentRoute) {
                this.waitForElement(e.attachTo.element, 0)
                    .then(function () {
                    _this.tour.cancel();
                    _this.tour.next();
                })
                    .catch(function () {
                    throw new Error('Error detected in loading');
                });
            }
        };
        TourServiceService.prototype.navigationCheckBack = function (event, e) {
            var _this = this;
            if (event instanceof i2.NavigationEnd && event.url === e.currentRoute) {
                this.waitForElement(e.attachTo.element, 0)
                    .then(function () {
                    _this.tour.cancel();
                    _this.tour.back();
                })
                    .catch(function () {
                    throw new Error('Error detected in loading');
                });
            }
        };
        TourServiceService.prototype.waitForElement = function (querySelector, timeout) {
            var _this = this;
            if (timeout === void 0) { timeout = 0; }
            var startTime = new Date().getTime();
            return new Promise(function (resolve, reject) {
                var timer = setInterval(function () {
                    var now = new Date().getTime();
                    if (document.querySelector(querySelector)) {
                        clearInterval(timer);
                        resolve();
                    }
                    else if (timeout && now - startTime >= timeout) {
                        clearInterval(timer);
                        reject();
                    }
                    else {
                        // do nothing
                    }
                }, _this.interval);
            });
        };
        TourServiceService.prototype.triggerTour = function (tourInstance) {
            var _this = this;
            var removedSteps;
            var sessionId = this.tourStoreService.getSessionId();
            this.tourStoreService
                .loadState({ tourId: tourInstance.tourId, sessionId: sessionId })
                .subscribe(function (currentStep) {
                if (currentStep) {
                    var f_1 = true;
                    removedSteps = tourInstance.tourSteps.filter(function (e) {
                        if (e.id === currentStep.step || !f_1) {
                            f_1 = false;
                        }
                        return f_1;
                    });
                    var flag_1 = false;
                    tourInstance.tourSteps = tourInstance.tourSteps.filter(function (e) {
                        if (e.id === currentStep.step || flag_1) {
                            flag_1 = true;
                        }
                        return flag_1;
                    });
                }
                else {
                    _this.tourStoreService.generateSessionId();
                }
                tourInstance.tourSteps.forEach(function (e) {
                    e.buttons.forEach(function (b) {
                        var key = b.key;
                        var func = _this.tourStoreService.getFnByKey(key);
                        var wrapperNext = function () {
                            _this.tourStoreService.saveState({
                                tourId: tourInstance.tourId,
                                state: {
                                    sessionId: _this.tourStoreService.getSessionId(),
                                    step: e.nextStepId,
                                },
                            });
                            _this.router.navigate([e.nextRoute]);
                            _this.router.events.subscribe(function (event) {
                                var nextStep = tourInstance.tourSteps.filter(function (ts) { return ts.id === e.nextStepId; })[0];
                                _this.navigationCheckNext(event, nextStep);
                            });
                        };
                        var wrapperPrev = function () {
                            _this.tourStoreService.saveState({
                                tourId: tourInstance.tourId,
                                state: {
                                    sessionId: _this.tourStoreService.getSessionId(),
                                    step: e.prevStepId,
                                },
                            });
                            _this.router.navigate([e.prevRoute]);
                            _this.router.events.subscribe(function (event) {
                                var prevStep = tourInstance.tourSteps.filter(function (ts) { return ts.id === e.prevStepId; })[0];
                                _this.navigationCheckBack(event, prevStep);
                            });
                        };
                        var wrapperNormalNext = function () {
                            _this.tourStoreService.saveState({
                                tourId: tourInstance.tourId,
                                state: {
                                    sessionId: _this.tourStoreService.getSessionId(),
                                    step: e.nextStepId,
                                },
                            });
                            _this.tour.cancel();
                            _this.tour.next();
                        };
                        var wrapperNormalPrev = function () {
                            _this.tourStoreService.saveState({
                                tourId: tourInstance.tourId,
                                state: {
                                    sessionId: _this.tourStoreService.getSessionId(),
                                    step: e.prevStepId,
                                },
                            });
                            _this.tour.cancel();
                            _this.tour.back();
                        };
                        _this.actionAssignment(e, b, wrapperNormalNext, wrapperNormalPrev, wrapperNext, wrapperPrev, func);
                    });
                });
                _this.tour.addSteps(tourInstance.tourSteps);
                _this.tour.start();
                if (removedSteps !== undefined) {
                    removedSteps.forEach(function (er) {
                        er.buttons.forEach(function (br) {
                            var k = br.key;
                            var funcRemoved = _this.tourStoreService.getFnByKey(k);
                            var wrapperNextRemoved = function () {
                                _this.tourStoreService.saveState({
                                    tourId: tourInstance.tourId,
                                    state: {
                                        sessionId: _this.tourStoreService.getSessionId(),
                                        step: er.nextStepId,
                                    },
                                });
                                _this.router.navigate([er.nextRoute]);
                                _this.router.events.subscribe(function (event) {
                                    _this.navigationCheckNext(event, er);
                                });
                            };
                            var wrapperPrevRemoved = function () {
                                _this.tourStoreService.saveState({
                                    tourId: tourInstance.tourId,
                                    state: {
                                        sessionId: _this.tourStoreService.getSessionId(),
                                        step: er.prevStepId,
                                    },
                                });
                                _this.router.navigate([er.prevRoute]);
                                _this.router.events.subscribe(function (event) {
                                    _this.navigationCheckBack(event, er);
                                });
                            };
                            var wrapperNormalNextRemoved = function () {
                                _this.tourStoreService.saveState({
                                    tourId: tourInstance.tourId,
                                    state: {
                                        sessionId: _this.tourStoreService.getSessionId(),
                                        step: er.nextStepId,
                                    },
                                });
                                _this.tour.cancel();
                                _this.tour.next();
                            };
                            var wrapperNormalPrevRemoved = function () {
                                _this.tourStoreService.saveState({
                                    tourId: tourInstance.tourId,
                                    state: {
                                        sessionId: _this.tourStoreService.getSessionId(),
                                        step: er.prevStepId,
                                    },
                                });
                                _this.tour.cancel();
                                _this.tour.back();
                            };
                            _this.actionAssignment(er, br, wrapperNormalNextRemoved, wrapperNormalPrevRemoved, wrapperNextRemoved, wrapperPrevRemoved, funcRemoved);
                        });
                    });
                    _this.tour.addSteps(removedSteps);
                    _this.addRemovedSteps(removedSteps);
                }
            });
        };
        TourServiceService.prototype.run = function (tourId) {
            var _this = this;
            this.tourStoreService.loadTour({ tourId: tourId }).subscribe(function (tourInstance) {
                if (tourInstance) {
                    _this.triggerTour(tourInstance);
                }
                else {
                    throw new Error('Tour does not exist');
                }
            });
        };
        return TourServiceService;
    }());
    TourServiceService.ɵprov = i0.ɵɵdefineInjectable({ factory: function TourServiceService_Factory() { return new TourServiceService(i0.ɵɵinject(TourStoreServiceService), i0.ɵɵinject(i2.Router)); }, token: TourServiceService, providedIn: "root" });
    TourServiceService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    TourServiceService.ctorParameters = function () { return [
        { type: TourStoreServiceService },
        { type: i2.Router }
    ]; };

    var prefix = "<vg-player><vg-overlay-play></vg-overlay-play><vg-buffering></vg-buffering>\n<vg-scrub-bar><vg-scrub-bar-current-time></vg-scrub-bar-current-time><vg-scrub-bar-buffering-time></vg-scrub-bar-buffering-time></vg-scrub-bar>\n<vg-controls><vg-play-pause></vg-play-pause> <vg-playback-button></vg-playback-button><vg-time-display vgProperty=\"current\" vgFormat=\"mm:ss\">\n</vg-time-display><vg-scrub-bar style=\"pointer-events: none;\"></vg-scrub-bar><vg-time-display vgProperty=\"left\" vgFormat=\"mm:ss\"></vg-time-display>\n<vg-time-display vgProperty=\"total\" vgFormat=\"mm:ss\"></vg-time-display><vg-track-selector></vg-track-selector><vg-mute ></vg-mute><vg-volume></vg-volume>\n<vg-fullscreen></vg-fullscreen></vg-controls>\n<video width=\"100%\" controls disablepictureinpicture controlslist=\"nodownload\" [vgMedia]=\"$any(media)\" #media id= \"singleVideo\" preload=\"auto\" controls><source src = \"";
    var suffix = '"type = video/webm type="video/mp4"> </video></vg-player>';

    /*
     * Public API Surface of user-onboarding-lib
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.TourServiceService = TourServiceService;
    exports.TourStoreServiceService = TourStoreServiceService;
    exports.UserOnboardingLibModule = UserOnboardingLibModule;
    exports.prefix = prefix;
    exports.suffix = suffix;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sourceloop-user-onboarding-client.umd.js.map
